#ifndef PAINTER_3D_H
#define PAINTER_3D_H

#ifndef PAINTER_2D_H
#include "Painter_2D.h"
#endif

#ifndef LIGHT_MODEL_H
#include "Light_model.h"
#endif

class Image_3D;
class Z_buffer;
class View_abstract_sphere;

class Painter_3D : public Painter_2D
{
    Image_3D                   &image_3D_;

public :                                //fix
    Z_buffer                   *z_buf_;
//    Light_model                *LM_ex_;

public:
    //static Z_buffer            *ini_z_buf_;
    Light_model                 light_model_;

    //      void                        clear();
    //void                        line( int x1, int y1, int x2, int y2 );
    
    Painter_3D(Image_3D & image_3D  );
    
    void                        line( int XStart, int YStart, 
                                      int XEnd, int YEnd );


    void                        Wu_line(  int x1, int y1, int z1,
                                          int x2, int y2, int z2 );
    void                        Wu_line2( int x1, int y1, int z1,
                                          int x2, int y2, int z2 );
    void                        Wu_line3( int x1, int y1, int z1,
                                          int x2, int y2, int z2 );

    void                        sphere( int R, int X, int Y, int Z );
    void                        sphere( View_abstract_sphere * sphere,
                                        int Z_clip=0 ); //fix =0
    void                        crude_sphere( View_abstract_sphere * sphere,
                                              int Z_clip, int draw_resolution );
    void                        crude_sphere2( View_abstract_sphere * sphere,
                                              int Z_clip, int draw_resolution );

    void                        clear();
};

#endif //PAINTER_3D_H
