#ifndef OPENRM_ATOM_H
#define OPENRM_ATOM_H

#ifndef VISUAL_ATOM_H
#include "Visual_atom.h"
#endif

class View_atom_type;
class QRMWidget;

extern "C" 
{
struct RMprimitive;
struct RMnode;
}

namespace MM
{

class OpenRM_atom : public Visual_atom
{
    RMprimitive             *sphere_;
    RMnode                  *atom_node_;
    RMnode                  *parent_node_;
    QRMWidget               *rm_widget_;
    mutable bool            show_flag_;

public:
    OpenRM_atom (RMnode *parent_node, QRMWidget *rm_widget);
    ~OpenRM_atom();
    virtual Visual_atom *   clone () const;

//    bool                    is_shown ()         {return show_flag_;}
    void                    show () const;
    void                    hide () const;
    void                    update () const;
    void                    update_view_type   (View_atom_type & type);
    void                    update_coordinates (double x, double y, double z);
    //virtual void            get_color          (int *R, int *G, int *B);
    void                    set_color          (int R,  int G,  int B);
    void                    set_level_of_details (int lod) ;
};

}//MM

#endif //OPENRM_ATOM_H
