#ifndef VISUAL_ATOM_COMPOSITE_H
#define VISUAL_ATOM_COMPOSITE_H

#ifndef VISUAL_ATOM_H
#include "Visual_atom.h"
#endif

#ifndef ARRAY_OF_OWN_H
#include "Array_of_own.h"
#endif

namespace MM
{

class Visual_atom_composite : public Visual_atom
{
    Array_of_own <Visual_atom>       atom_;

public:
    Visual_atom *   clone () const;
    int             count () const                {return atom_.size();}
    void            adopt (Visual_atom *adoptee);

    void            show () const;
    void            hide () const;
    void            update_view_type   (View_atom_type & type);
    void            update_coordinates (double x, double y, double z);
    //void            get_color          (int *R, int *G, int *B);
    void            set_color          (int R, int G, int B);
    void            set_level_of_details (int lod);
};

}//MM

#endif //VISUAL_ATOM_COMPOSITE_H
