#ifndef BOND_KIT_H
#define BOND_KIT_H

#ifndef BOND_CACHE_H
#include "Bond_cache.h"
#endif

#ifndef FLAG_H
#include "Flag.h"
#endif

#ifndef TEXT_H
#include "Text.h"
#endif

namespace MM
{

class Bond_kit
{
    Text                                    comment_;

public:
    Text const &    comment_line () const               {return comment_;}
    void            set_comment_line  (Text const &v)   {comment_ = v;}

    // ChemCon //////////////////////////////////////////////////////////////
    enum   //fix
    {
        already_used = 1, mark_1_2 = 2, mark_1_3 = 4, mark_1_4 = 8,
        hetero = 16, has_improper_torsion = 32, united = 64, selected = 128,
        coords_was_changed = 256, already_calculated = 512, missed = 1024
    };

    Bond_cache              *cache___;
};

}//MM

#endif //BOND_KIT_H
