#include "Graphic_configuration.h"

#include "Abstracts.h"
#include "Prototype_repository.h"
//#include "Any_ptr.h"

//#include "Main_window.h"
#include "Form_main_window_user.h"
#include "Qt_interface.h"
#include "Qt_text_output.h"
#include "Add_model_dialog.h"
//#include "SoQt_application.h"
#include "MolMeccano_application.h"
#include "Model.h"
#include "Project.h"
#include "Model_kit.h"
//#include "Qt_simulation_task.h"
//#include "Atom.h"
///#include "Atom_impl.h"

//#include "Molecule_impl.h"
///#include "Default_id.h"
//#include "Inventor_atom_attributes.h"
#include "Default_component.h"
//#include "Default_bond.h"

//#include "Model_impl.h"
//#include "Model_manager_impl.h"

//#include <qwidget.h>
#include "Project_impl.h"

#include "Form_protocol.h"
#include "Qt_protocol_view.h"

#include "Form_monitors.h"
#include "Form_information.h"
#include "Form_geometry.h"
#include "Form_add_model.h"


namespace MM
{
//Text application_name;      //fix move to application

Graphic_configuration::
Graphic_configuration (int argc, char * argv[])
:
    Configuration (argc, argv)
{
//    new QApplication (argc, argv);
//    return;

    //application_name = argv[0];
    Prototype_repository & repository = Prototype_repository::singleton();

    repository.refer ((Application*)    new MolMeccano_application(argc,argv));
///    return;
    

//    Any::Adopt aaa(new int);
//    repository.adopt (aaa);
//    repository.adopt (Any::Adopt(new int));
//    repository.adopt (new int);
//    Any_ptr a(new int);
//    Any_ptr aa(new Form_main_window_user);
  
    repository.adopt ((Protocol_view*)  new Qt_protocol_view);
    repository.adopt ((Project*)        new Project_impl());
//    repository.adopt (new Main_window(),                typeid (Main_window));
    repository.adopt ((User*)           new Form_main_window_user());
//    repository.adopt (new Qt_text_output(),             typeid (Text_output));
///    repository.refer ((Application*)    new MolMeccano_application(argc,argv));
//    repository.adopt ((Application*)    new MolMeccano_application(argc,argv));
    //repository.adopt (new SoQt_application(argc,argv),  typeid (Application));
    //repository.adopt (new Qt_application (argc,argv),   typeid (Application));
    repository.adopt ((User_interface*) new Qt_interface());
//    repository.adopt ((Simulation_task*)new Qt_simulation_task());

    //repository.adopt ((ID*)(new Default_id()),                 typeid (ID));
///    repository.adopt ((ID*)             new Default_id());
    
///    Atom_impl *atom = new Atom_impl (Element("C"));
//    ::Atom *atom = new ::Atom ();
    //atom.add_visual (new OpenRM_atom (rm_widget->object_node(), rm_widget));
///    atom->kit().add_hyperchem_attributes (new Hyperchem_attributes(*atom)); //fix
///    repository.adopt ((Atom*) atom);

    class Qt_add_model_dialog : public Add_model_dialog
    {
    public:
        void execute () {Form_add_model::pop_up();}
    };
    repository.adopt ((Add_model_dialog*) new Qt_add_model_dialog());

    
    repository.adopt ((Component*)      new Default_component());
    /*repository.adopt ((Bond*)           new Default_bond());
    repository.adopt ((Molecule*)       new Molecule_impl());

    repository.adopt ((Model*)          new Model_impl());
    repository.adopt ((Model_manager*)  new Model_manager_impl());///*/

    class Qt_show_protocol : public Show_protocol
    {
        void        execute ()        {Form_protocol::pop_up ();}
        Command *   clone   () const  {return new Qt_show_protocol;}
    };
    repository.adopt ((Show_protocol*)  new Qt_show_protocol);

    class Qt_show_monitor : public Show_monitor
    {
        void        execute ()        {Form_monitors::pop_up ();}
        Command *   clone   () const  {return new Qt_show_monitor;}
    };
    repository.adopt ((Show_monitor*)  new Qt_show_monitor);

    class Qt_show_information : public Show_information
    {
        void        execute ()        {Form_information::pop_up ();}
        Command *   clone   () const  {return new Qt_show_information;}
    };
    repository.adopt ((Show_information*)  new Qt_show_information);

    class Qt_show_geometry : public Show_geometry
    {
        void        execute ()        {Form_geometry::pop_up ();}
        Command *   clone   () const  {return new Qt_show_geometry;}
    };
    repository.adopt ((Show_geometry*)  new Qt_show_geometry);

    class Qt_show_model_movement : public Show_model_movement
    {
        void        execute ()        {Form_add_model::pop_up ();}
        Command *   clone   () const  {return new Qt_show_model_movement;}
    };
    repository.adopt ((Show_model_movement*)  new Qt_show_model_movement);

    class Set_Z_viewpoint_impl : public Set_Z_viewpoint
    {
        void        execute ()        {Project::singleton ().current_model().kit().view().flush_camera();}
        Command *   clone   () const  {return new Set_Z_viewpoint_impl;}
    };
    repository.adopt ((Set_Z_viewpoint*)  new Set_Z_viewpoint_impl);
}

}//MM

