#include "Test.h"

#include "Own.h"
#include "Path.h"
#include "Create.h"
#include "Atom.h"
#include "Atom_kit.h"
#include "Model.h"
#include "Model_kit.h"
#include "Form_model.h"
#include "QRMWidget.h"
#include "OpenRM_model_view.h"
#include "Timer.h"
#include "User.h"
#include "Qt_application.h"
#include "Form_main_window.h"

namespace MM
{

class Graphic_speed_test : public Test
{
public:
    Graphic_speed_test (const Text& suite_name) : Test (suite_name) { }

    void run()
    {
        test_1aon();   count_tests();
    }

    void test_1aon()
    {
        Text text;
        Model *model = prototype <Model> ().clone();

        //fix remove /////////////////////////////////////////////
        QRMWidget *rm_widget = new QRMWidget ();
        Form_model *MDI_window =  new Form_model (*model, rm_widget);
        rm_widget->setFixedSize  (800, 600); 

        Form_main_window &main_window 
            = MM::Qt_application::singleton().main_window();
        main_window.add_MDI_window (MDI_window, "Demo");

        OpenRM_model_view *view = 
            new OpenRM_model_view (*model, *rm_widget, *MDI_window);
        model->kit().add_view (view);

        rm_widget->show ();

        model->atom_prototype().kit().add_visual
            (new OpenRM_atom (rm_widget->object_node(), rm_widget));
        //fix remove /////////////////////////////////////////////

        model->load (Path::tests() + "C3H4.xyz");
        model->kit().view().fit_to_screen();
        view->set_level_of_details (3);

        Timer t;
        rm_widget->demo_rotation (1000);
        text += t.elapsed();
        text += " sec     ";
        to_user().status (text);

        model->load (Path::tests() + "3cro.pdb");
        model->kit().view().fit_to_screen();
        view->set_level_of_details (2);

        t.restart();
        rm_widget->demo_rotation (1000);
        text += t.elapsed();
        text += " sec     ";
        to_user().status (text);

        model->load (Path::tests() + "pdb1aon.ent");
        model->kit().view().fit_to_screen();
        view->set_level_of_details (0);

        t.restart();
        rm_widget->demo_rotation (50);
        text += t.elapsed();
        text += " sec     ";
        to_user().status (text);//*/

        rm_widget->close();
        //delete rm_widget;
        delete model;//fix speed
    }
};

Graphic_speed_test test_graphic_speed ("demo");

}//MM
