#include "Composite_interaction.h"

namespace MM
{

double Composite_interaction::
potential ()
{
    double result = 0;

    for (int i=0;  i<interaction_.size();  ++i)
        result += interaction_[i].potential ();

    return result;
}

void Composite_interaction::
add_force ()
{
    for (int i=0;  i<interaction_.size();  ++i)
        interaction_[i].add_force ();
}

void Composite_interaction::
report (Text *result, Text const & hint)
{
    for (int i=0;  i<interaction_.size();  ++i)
        interaction_[i].report (result, hint);
}

void Composite_interaction::
adopt (Interaction *adoptee)
{
    interaction_.adopt (adoptee);
}

}//MM
