#ifndef DURATION_UNIT_H
#define DURATION_UNIT_H

#ifndef UNIT_H
#include "Unit.h"
#endif

namespace MM
{

class Duration_unit : public Unit
{
    double      value_;         // ps
    double      step_length_;

public:
                Duration_unit ();
    explicit    Duration_unit (double);
    Unit *      clone () const;

    double      ps        () const        {return   value_;}
    void        set_ps    (double value)  {value_ = value;}

    double      steps           () const        {return   value_/ step_length_;}
    void        set_steps       (double steps)  {value_ = steps * step_length_;}
    double      step_length     () const        {return step_length_;}
    void        set_step_length (double value)  {step_length_ = value;}

    double      fs      () const        {return       1000. *value_;}
    void        set_fs  (double value)  {value_ = 1./ 1000. *value;}

    double      ns      () const        {return   1./ 1000. *value_;}
    void        set_ns  (double value)  {value_ =     1000. *value;}

    double      sec     () const        {return   1./ 1.e12 *value_;}
    void        set_sec (double value)  {value_ =     1.e12 *value;}

    // Unit interface
    double      value (Text const & current_type) const;
    void        set_value (double new_value, Text const & current_type);

    int         type_count () const     {return 5;}
    Text const& type (int n)  const;
};

}//MM

#endif //DURATION_UNIT_H
