#include "Form_information.h"

#include "Form_main_window.h"
#include "Qt_application.h"
#include "Information.h"
#include "Project.h"

namespace MM
{
Form_information::
Form_information ()
:
    add_log_(0)//,
    //refresh_model_(0)
{
    setupUi (this);

    QFont f("Courier", 10, QFont::Bold);
    textEdit->setFont(f);
    //QFont f = textEdit->font ();
    //f.setPointSize (11);
    textEdit->setFont(f);

    pushButton_Selected->setEnabled (false);

    connect (pushButton_Model,      SIGNAL(clicked()),
             this,                  SLOT  (model()));

    connect (pushButton_Selected,   SIGNAL(clicked()),
             this,                  SLOT  (selected()));

    connect (pushButton_Project,    SIGNAL(clicked()),
             this,                  SLOT  (project()));

    connect (pushButton_Session,    SIGNAL(clicked()),
             this,                  SLOT  (session()));

    connect (pushButton_Problems,   SIGNAL(clicked()),
             this,                  SLOT  (problems()));

    connect (pushButton_Log,        SIGNAL(clicked()),
             this,                  SLOT  (log()));

    connect (pushButton_Log,        SIGNAL(toggled   (bool)),
             this,                  SLOT  (toggle_log(bool)));
}

Form_information::
~Form_information ()
{
    if (add_log_)
        Information::singleton().on_log (add_log_, false);
    add_log_ = 0;
}

void Form_information::
pop_up ()
{
    Form_main_window &main_window 
        = Qt_application::singleton().main_window();

    if (Form_information::exist())
        main_window.pop_up (Form_information::singleton());
    else
        main_window.add_bottom_control
            (Form_information::singleton(), "Information");
}

void Form_information::
showEvent (QShowEvent * event)
{
    if (Project::singleton().model_count() != 0)
        reset ();

    QWidget::showEvent(event);
}

void Form_information::
reset (Model_event::Hint)
{
    if (pushButton_Model->isChecked ())
        model ();

    if (pushButton_Selected->isChecked ())
        selected ();

    if (pushButton_Project->isChecked ())
        project ();
}

void Form_information::
session ()
{
    Text result;
    Information::singleton().session (result);
    textEdit->setHtml (result.c_str ());
}

void Form_information::
project ()
{
    Text result;
    Information::singleton().project (result);
    textEdit->setHtml (result.c_str ());
}

void Form_information::
model ()
{
    //Text result ("<h3><b>Model</b></h3>");
    Text result;
    Information::singleton().model (result);
    textEdit->setHtml (result.c_str ());
}

void Form_information::
selected ()
{
    Text result;
    Information::singleton().selected (result);
    textEdit->setHtml (result.c_str ());
}

void Form_information::
problems ()
{
    Text result;
    Information::singleton().problems (result);
    textEdit->setHtml (result.c_str ());
}

void Form_information::
log ()
{
    Text result;
    Information::singleton().log (result);
    textEdit->setPlainText (result.c_str ());
    textEdit->moveCursor (QTextCursor::End);
}

void Form_information::
toggle_log (bool checked)
{
    if (checked)
    {
        CHECK ("add_log_ command exist.", add_log_ == 0);

        class Add_log : public Command
        {
        public:
            void    execute () {Form_information::singleton()->log();}
        };
        add_log_ = new Add_log;
        Information::singleton().on_log (add_log_, true);
    }
    else
    {
        CHECK ("add_log_ command exist.", add_log_ != 0);
        Information::singleton().on_log (add_log_, false);
        add_log_ = 0;
    }
}

/*void Form_information::
toggle_model (bool checked)
{
    if (checked)
    {
        class Refresh_model : public Command_1 <Model&>
        {
        public:
            void    execute (Model &) 
            {
                Form_information::singleton()->log();
                Form_information::singleton()->log();
            }
        };
        refresh_model_ = new Refresh_model;
        Project::singleton().on_change_current (refresh_model_, true);
    }
    else
    {
        Project::singleton().on_change_current (refresh_model_, false);
    }
}//*/

}//MM
