#ifndef FORM_INFORMATION_H
#define FORM_INFORMATION_H

#include "ui_Form_information.h"
#include "Dynamic_singleton.h"
#include "Model_singleton_view.h"

namespace MM
{
class Command;

class Form_information
:
    public QWidget,
    public Ui::Form_information,
    public Dynamic_singleton <Form_information>,
    public Model_singleton_view
{
    Q_OBJECT

    friend class Dynamic_singleton <Form_information>;

    Command *       add_log_;
    //Command *       refresh_model_;

public:
    Form_information();
   ~Form_information();
    
    static void     pop_up ();

    void            reset_current_model (Model &) {reset();}
    void            reset (Model_event::Hint
                         = Model_event::Structure_changed);

public slots:
    virtual void    showEvent (QShowEvent * event);

    void            session  ();
    void            project  ();
    void            model    ();
    void            selected ();
    void            problems ();
    void            log      ();

    void            toggle_log   (bool checked);
    //void            toggle_model (bool checked);
};

}//MM

#endif //FORM_INFORMATION_H
