#include "Pressure_unit.h"

#include "Flaw.h"

namespace MM
{

Unit * Pressure_unit::
clone () const
{
    Pressure_unit *result   = new Pressure_unit;
    result->current_type_ = current_type_;
    result->value_        = value_;
    return result;
}

double Pressure_unit::
value (Text const & current_type) const
{
    if      (current_type == "atm")
        return atm ();

    else
        FLAW (Text() + "Unknown Pressure_unit '" + current_type + "'.");
}

void Pressure_unit::
set_value (double new_value, Text const & current_type)
{
    if      (current_type == "atm")
        set_atm (new_value);

    else
        FLAW (Text() + "Unknown Pressure_unit '" + current_type + "'.");
}

Text const& Pressure_unit::
type (int n)  const
{
    static const Text atm = "atm";

    switch (n)
    {
    case 0: return atm;

    default: FLAW ("Out of range.");
    }
}

}//MM
