#ifndef FORM_PROTOCOL_H
#define FORM_PROTOCOL_H

#ifndef UI_FORM_PROTOCOL_H
#include "ui_Form_protocol.h"
#endif

#ifndef DYNAMIC_SINGLETON_H
#include "Dynamic_singleton.h"
#endif

#ifndef MODEL_SINGLETON_VIEW_H
#include "Model_singleton_view.h"
#endif

class QDirModel;

namespace MM
{

class Form_protocol
:
    public QWidget,
    public Ui::Form_protocol,
    public Dynamic_singleton <Form_protocol>,
    public Model_singleton_view
{
    Q_OBJECT

    friend class Dynamic_singleton <Form_protocol>;
    Form_protocol ();

    QDirModel *             dir_model;
    bool                    stop_flag_;

    class Run_state
    {
        //Form_protocol &   form_;

    public:
        explicit Run_state (Form_protocol & form);
                ~Run_state ();

        void     apply (Form_protocol & form);
    };

    friend class Run_state;
    static Run_state * run_state_;

public:

    static  void            pop_up ();

    void                    reset_current_model (Model &);
    void                    reset (Model_event::Hint) {}

public slots:
    void                    run   ();
    void                    stop ();
    void                    tune  ();
    void                    start ();

private slots:
    void                    choose_protocol (const QModelIndex & index);
    void                    choose_step     (const QModelIndex & index);
    void                    show_options    ();
    
protected:
    void                    showEvent (QShowEvent * event);
};

}//MM

#endif //FORM_PROTOCOL_H
