#ifndef MD_METHOD_H
#define MD_METHOD_H

#ifndef DBC_H
#include "DbC.h"
#endif

#ifndef MD_H
#include "MD.h"
#endif

namespace MM
{
//class MD;
//class MD_subject;
class Prototype;

class MD_method : protected DbC
{
//    MD_subject *                        subject_;
    MD *                                simulation_;

public:
    static MD_method *          create (Text const & method);
    static int                  prototype_count ();
    static MD_method &          prototype (int n);
    static void                 adopt_prototype (MD_method * method);

//    explicit MD_method (MD_subject & subject) : subject_(&subject) { }
    MD_method () : simulation_(0) { }
    virtual ~MD_method ();

    virtual MD_method * clone () const =0;
    virtual char const* class_name () const =0;
    virtual Text const& title () const =0;       //fix to char const*

    virtual void        start  ();
    virtual void        step   () =0;
    virtual void        finish ();

    virtual bool        support_thermostat () const {return false;}
    virtual bool        support_barostat   () const {return false;}
    virtual bool        has_thermostat     () const {return false;}
    virtual bool        has_barostat       () const {return false;}
    virtual void        set_thermostat     (bool)   {FLAW("Not implemented.");}
    virtual void        set_barostat       (bool)   {FLAW("Not implemented.");}

    MD &        simulation ()                     {return *simulation_;}
    MD const &  simulation () const               {return *simulation_;}
    void        set_simulation (MD & simulation)  {simulation_ = &simulation;}
    virtual int iterations () const               {return simulation_->steps();}

protected:
    void kick (double h);
    void drift(double h);

    virtual bool invariant() const    {return simulation_ != 0;}
};

}//MM

#endif //MD_METHOD_H
