#ifndef OVVL_H
#define OVVL_H

#ifndef OVL_H
#include "OVL.h"
#endif

namespace MM
{

class OVVL : public OVL
{
public:
    explicit OVVL (Prototype const &) {adopt_prototype (this);}
    explicit OVVL () { }
    //explicit OVVL (MD_subject & subject) : OVL (subject) { }
    char const *    class_name () const {return "OVVL";}
    MD_method *     clone () const      {return new OVVL;}

protected:
    virtual Text const& title () const
    {
        static const Text name = "Optimized Velocity Verlet-Like";
        return name;
    }

    virtual void        step   ()
    {
        kick  (xi());
        drift (0.5);
        kick  (1.-2.*xi());
        drift (0.5);
        kick  (xi());
    }
};

}//MM

#endif //OVVL_H
