#ifndef VELOCITY_LEAPFROG_H
#define VELOCITY_LEAPFROG_H

#ifndef LEAPFROG_H
#include "Leapfrog.h"
#endif

namespace MM
{

class Velocity_leapfrog : public Leapfrog
{
public:
    explicit Velocity_leapfrog (Prototype const &) {adopt_prototype (this);}
    explicit Velocity_leapfrog () { }
    //explicit Velocity_leapfrog (MD_subject & subject) : Leapfrog (subject) { }
    char const *    class_name () const {return "Velocity_leapfrog";}
    MD_method *     clone () const      {return new Velocity_leapfrog;}

protected:
    virtual Text const& title () const
    {
        static const Text name = "Velocity leapfrog";
        return name;
    }

    virtual int         iterations () const {return simulation().steps()-1;}

    virtual void        start  ()
    {
        //MD::start ();
        kick  (.5);
    }
    virtual void        step   ()
    {
        drift (1.);
        kick  (1.);
    }
    virtual void        finish ()
    {
        drift (1.);
        kick  (.5);
        //MD::finish ();
    }
};

}//MM

#endif //VELOCITY_LEAPFROG_H
