#ifndef FORM_ADD_MODEL_H
#define FORM_ADD_MODEL_H

#include "ui_Form_add_model_base.h"
#include "Dynamic_singleton.h"
#include "Model_singleton_view.h"

namespace MM
{
class Model;
class Add_builder;
class Model;
class Command;

class Form_add_model :
    public QWidget,
    public Ui::Form_add_model_base,
    public Dynamic_singleton <Form_add_model>,
    public Model_singleton_view
{
    Q_OBJECT

    friend class Dynamic_singleton <Form_add_model>;
    Model &         model ();
    Add_builder &   builder ();

    //Command *       update_me_;

public:
    Form_add_model ();
    virtual        ~Form_add_model ();

    void            update_form    ();
    void            reset_current_model (Model &);
    void            reset (Model_event::Hint) {}

    static void     pop_up ();

public slots:
    virtual void    showEvent (QShowEvent * event);

    void            up_clicked   ();
    void            in_clicked   ();
    void            left_clicked ();
    void            right_clicked();
    void            out_clicked  ();
    void            down_clicked ();

    void            right_X_clicked  ();
    void            left_X_clicked   ();
    void            right_Y_clicked  ();
    void            left_Y_clicked   ();
    void            right_Z_clicked  ();
    void            left_Z_clicked   ();

    void            flush_camera_clicked ();

    void            pushButton_OK_clicked           ();
    void            pushButton_Cancel_clicked       ();

    void            checkBox_No_overlap_toggled (bool);
    void            lineEdit_Translation_increment_textChanged (const QString&);
    void            lineEdit_Rotation_increment_textChanged    (const QString&);
};

}//MM

#endif // FORM_ADD_MODEL_H
