#include "Path.h"

#include "Create.h"
#include "Application.h"
//#include "Graphic_configuration.h"

namespace MM
{

namespace Path
{

char * start_dir ()
{
    static char instance [1024];
    return      instance;
}

Text 
prefix ()
{
#if defined (MM_CORE)
    return home ();
#else
    #if defined(WIN32)
        return home () + ("MolMeccano\\");
    #else
        return home () + ("MolMeccano/");
    #endif
#endif
}

Text &
home ()  
{
    static Text win32 ("..\\");
    static Text unix_home  ("../");

#if defined(WIN32)
    return win32;
#else
    return unix_home;
#endif
}

#if defined(WIN32)
    Text working                     () {return Text(start_dir()) + "\\";}
    Text bin                         () {return home() + "bin\\";}
    Text doc                         () {return home() + "doc\\";}

    //Text bin                         () {return ".\\";}
    Text report                      () {return prefix() + "Report\\";}
    Text aminoacids_billets          () {return prefix() + "Repository\\- Amino Acids\\Aminoacids\\Billets\\";}
    Text aminoacids                  () {return prefix() + "Repository\\- Amino Acids\\";}
    Text aminoacids_20               () {return prefix() + "Repository\\- Amino Acids\\Aminoacids\\20\\";}
    Text aminoacids_tinker           () {return prefix() + "Repository\\- Amino Acids\\tinker\\";}
    Text repository                  () {return prefix() + "Repository\\";}
    Text parameters                  () {return prefix() + "Parameters\\";}
    Text protocol                    () {return prefix() + "Protocols\\";}
    Text icon                        () {return prefix() + "icon\\";}
    Text tests                       () {return prefix() + "Tests\\";}
    Text tests_rubbish               () {return prefix() + "TestsRubbish\\";}
    Text force_field                 () {return prefix() + "ForceField\\";}
    Text m_dynamix                   () {return bin();}         //fix
    Text m_dynamix_molecular_database() {return bin() + "moldb\\";}
#else
    Text working                     () {return Text(start_dir()) + "/";}
    Text bin                         () {return home() + "bin/";}
    Text doc                         () {return home() + "doc/";}

//Text bin                         () {return "./";}
    Text report                      () {return prefix() + "Report/";}
    Text aminoacids_billets          () {return prefix() + "Repository/- Amino Acids/Aminoacids/Billets/";}
    Text aminoacids                  () {return prefix() + "Repository/- Amino Acids/";}
    Text aminoacids_20               () {return prefix() + "Repository/- Amino Acids/Aminoacids/20/";}
    Text aminoacids_tinker           () {return prefix() + "Repository/- Amino Acids/tinker/";}
    Text repository                  () {return prefix() + "Repository/";}
    Text parameters                  () {return prefix() + "Parameters/";}
    Text protocol                    () {return prefix() + "Protocols/";}
    Text icon                        () {return prefix() + "icon/";}
    Text tests                       () {return prefix() + "Tests/";}
    Text tests_rubbish               () {return prefix() + "TestsRubbish/";}
    Text force_field                 () {return prefix() + "ForceField/";}
    Text m_dynamix                   () {return bin();}
    Text m_dynamix_molecular_database() {return bin() + "moldb/";}
#endif

}//Path

}//MM
