#ifndef FORM_GEOMETRY_H
#define FORM_GEOMETRY_H

#include "ui_Form_geometry.h"
#include "Dynamic_singleton.h"
#include "Model_singleton_view.h"

#include <QFont>

namespace MM
{
class Measure_geometry;
class Command;

class Form_geometry:
    public QWidget,
    public Ui::Form_geometry,
    public Dynamic_singleton <Form_geometry>,
    public Model_singleton_view
{
    Q_OBJECT

    friend class Dynamic_singleton <Form_geometry>;

    QFont           info_font_;
    Command *       update_state_command_;

public:
    Form_geometry ();
   ~Form_geometry ();

    static void     pop_up ();

    void            reset_current_model (Model &);
    void            reset (Model_event::Hint) {update_state ();}


public slots:
    virtual void    showEvent (QShowEvent * event);

    void            set_active_1 (bool);
    void            set_active_2 (bool);
    void            set_active_3 (bool);
    void            set_active_4 (bool);

    void            set_type_1 (const QString &);
    void            set_type_2 (const QString &);
    void            set_type_3 (const QString &);
    void            set_type_4 (const QString &);

    void            set_units  (const QString &);

    void            set_number_1 ();
    void            set_number_2 ();
    void            set_number_3 ();
    void            set_number_4 ();

    void            prepend_point(bool);
    void            append_point (bool);

    void            set_position_1   ();
    void            set_position_2   ();
    void            set_position_3   ();
    void            set_position_4   ();

    void            update_info      ();
    void            update_parameter ();
    void            update_state     ();

    void            new_parameter_value ();
    void            add_parameter_value ();

protected:
    Measure_geometry &  measure_geometry();
    void            set_position (int point, const char * text);
};

}//MM

#endif //FORM_GEOMETRY_H
