#ifndef AMINOACID_BUILDER_H
#define AMINOACID_BUILDER_H

#ifndef DEFS_H
#include "Defs.h"
#endif

#ifndef DBC_H
#include "DbC.h"
#endif

namespace MM
{
class Text;
class Model;
class Atom;
class Joint;

class Aminoacid_builder : protected DbC
{
    Model                   *model_;
    Atom                    *joint_1_;
    Atom                    *joint_2_;

public:
    Aminoacid_builder() : model_(0), joint_1_(0), joint_2_(0) { }

    void                    set_model (Model& model);
    void                    set_joint (Atom * joint);
    void                    set_joint (Atom * joint_1, Atom * joint_2);
    void                    add_aminoacid (const Text & residue_name,
                                           double phi   = __Pi__,
                                           double psi   = __Pi__,
                                           double omega = __Pi__ );
    void                    create_billet ();
    void                    break_bond (const Atom & atom_1, 
                                        const Atom & atom_2, 
                                        Joint & new_joint_1, 
                                        Joint & new_joint_2);

protected:

    virtual bool invariant() const
    {
        return model_ != 0 && joint_1_ != 0;
    }
};

}//MM

#endif //AMINOACID_BUILDER_H
