#ifndef FORM_MAIN_WINDOW_H
#define FORM_MAIN_WINDOW_H

#include <QMainWindow>
//#include <QCloseEvent>

#ifndef FORM_MODEL_H
#include "Form_model.h"
#endif

#ifndef ARRAY_H
#include "Array.h"
#endif

class QWorkspace;
class QTabBar;
class QVBoxLayout;
class QTabWidget;
class QSplitter;
class QString;
class QLabel;
class QMenu;

namespace MM
{

class Form_main_window : protected QMainWindow
{
    Q_OBJECT

    Array <QToolBar *>      tool_bar_;
    Array <QMenu*>          menu_;

public:
    //friend void Form_model::closeEvent (QCloseEvent * e); //fix


    QWorkspace              *workspace;
    QTabBar                 *tab_bar;
    QLabel                  *status_label;

    QSplitter               *vertical_splitter;
    QSplitter               *horizontal_left_splitter;
    QSplitter               *horizontal_right_splitter;

    QTabWidget              *tab_left;
    QTabWidget              *tab_right;
    QTabWidget              *tab_bottom;

    //QGridLayout             *layout;
    QVBoxLayout             *layout;

public:
//    Form_main_window (QWidget* parent = 0, const char* name = 0);
    Form_main_window ();
    ~Form_main_window ();

    QMainWindow *   parent() {return this;}

    void            set_status (const QString &text);

    void            add_MDI_window  (Form_model *render_area, const char *name);
    void            add_left_control   (QWidget *control, const QString &label);
    void            add_right_control  (QWidget *control, const QString &label);
    void            add_bottom_control (QWidget *control, const QString &label);

    void            pop_up             (QWidget *control);
    void            add_to_menu (const QString & menu_name, QAction *);
    void            insert_menu_separator (const QString & menu_name);

    QMenu *         menu     (QString const& title);
    QToolBar *      tool_bar (QString const& title);

    void            remove_empty_menus ();
    void            remove_empty_tool_bars ();

public slots:
    void            line_up ();

protected slots:
    //void            update_left_panel (QWidget * w);
    void            select_tab    (QWidget * widget);
    void            select_window (int n);
    void            remove_left_control ();
    void            remove_right_control ();
    void            remove_bottom_control ();

public slots:
    void            remove_render_area (int id);
};

}//MM

#endif //FORM_MAIN_WINDOW_H
