#include "Form_model.h"

#include "Form_main_window.h"

#include "Model.h"
#include "Model_kit.h"

#include <qtabbar.h>
#include <qworkspace.h>
#include <q3widgetstack.h>
//Added by qt3to4:
#include <QFocusEvent>
#include <QResizeEvent>
#include <QCloseEvent>
#include <QVBoxLayout>

namespace MM
{

Form_model::
Form_model (Model & model, QWidget * central_widget)
:
    model_(model),
    identifier_(-100),
    central_widget_(central_widget)
{
    setAttribute(Qt::WA_DeleteOnClose);

    QVBoxLayout *layout = new QVBoxLayout (this);
    layout->setMargin (0);
    layout->addWidget (central_widget);
}

/*Form_model::
Form_model (//Form_main_window & main_window,
            const char*   name,
            Qt::WFlags        fl)

:   
    //3 QWidget (main_window.workspace, name, fl | Qt::WDestructiveClose),
    QWidget (0, name, fl | Qt::WDestructiveClose),
    identifier_(-100),
    //main_window_(main_window),
    central_widget_(0)
{
    //setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)7, (QSizePolicy::SizeType)7, 0, 0, sizePolicy().hasHeightForWidth() ) );

    //resize (QSize(600, 480).expandedTo (minimumSizeHint()));
//fix 3    clearWState (WState_Polished);

    QVBoxLayout *layout = new QVBoxLayout (this);
}//*/

Form_model::
~Form_model()
{
    model_.erase();
    //destroy.publish();
}

/*void Form_model::
set_central_widget (QWidget *central_widget)
{
    REQUIRE ("No central widget yet.", central_widget_==0);
    central_widget_ = central_widget;
//    layout->addWidget (central_widget);
}//*/

void Form_model::
closeEvent (QCloseEvent * e)
{
    if (model_.kit().is_locked())
    {
        e->ignore ();
        return;
    }

    main_window_->remove_render_area (identifier_);
    QWidget::closeEvent (e);
}

/*void Form_model::
resizeEvent (QResizeEvent * event)
{
    QWidget::resizeEvent (event);

    //if (central_widget_ != 0)
    //    central_widget_->setGeometry (0,0, width(), height());
}//*/

void Form_model::
focusInEvent (QFocusEvent *event)
{
    QWidget::focusInEvent (event);
    focus_in.publish ();
}

void Form_model::
windowActivationChange (bool oldActive)
{
    QWidget::windowActivationChange (oldActive);

    if (isActiveWindow())
    {
       focus_in.publish ();//fix fo windowActivationChange_event?
    }
}

}//MM
