#include "Qt_table_lattice_presentation.h"

#include "Lattice.h"

#include <q3table.h>

namespace MM
{

Qt_table_lattice_presentation::
Qt_table_lattice_presentation (Q3Table & table)
:
    table_(&table)
{
}

Lattice_presentation *  Qt_table_lattice_presentation::
clone () const
{
    return new Qt_table_lattice_presentation (*table_);
}

void Qt_table_lattice_presentation::
full_update ()
{
    INVARIANT;

    int height = lattice().height();
    int width  = lattice().width ();

    for (int row=0;  row<height;  ++row)
    {
        for (int column=0;  column<width;  ++column)
        {
            Text text;
            lattice().get_text (row, column, text);
            table_->setText(row, column, QString::fromLocal8Bit (text.c_str()));
        }
    }
}

void Qt_table_lattice_presentation::
show ()
{
    full_update ();
}

}//MM
