#include "Test.h"

#include "Chemcon_presentation.h"
#include "Model.h"
#include "HyperChem_like_builder.h"
#include "ID.h"
#include "Atom.h"
#include "Create.h"

namespace MM
{

class Qt_chemcon_graphics_test : public Test
{
public:
    Qt_chemcon_graphics_test( const Text & suite_name ) : Test( suite_name ) { }

    void run()
    {
        test_methane();
    }

    virtual void    test_methane();
};

Qt_chemcon_graphics_test test_qt_chemcon_graphics ("temporary");


void    Qt_chemcon_graphics_test::
test_methane()                            //fix make method "create_methane"
{
    //MM_model        mm_model;           //fix remove
    //Zhorov_model    model( mm_model );
//    Chemcon_presentation   *presentation = Chemcon_presentation::create();
//    MM_model                model( presentation );
    Own <Model> model (prototype <Model> (). clone ());

    //HyperChem_like_builder model_builder (model(), model() ); //fix ( model, model )
    HyperChem_like_builder model_builder (model() ); //fix ( model, model )

    const ID & C  = model_builder.create_atom( Element(6) );
    
    const ID & H1 = model_builder.create_atom( Element(1) );
    model_builder.set_bond( C, H1, Order('s') );
    
    const ID & H2 = model_builder.create_atom( Element(1) );
    model_builder.set_bond( C, H2, Order('s') );
    
    const ID & H3 = model_builder.create_atom( Element(1) );
    model_builder.set_bond( C, H3, Order('s') );
    
    const ID & H4 = model_builder.create_atom( Element(1) );
    model_builder.set_bond( C, H4, Order('s') );

    model().atom( C ).set_x( 0 );
    model().atom( C ).set_y( 0 );
    model().atom( C ).set_z( 0 );

    model().atom( H1 ).set_x(-1 );
    model().atom( H1 ).set_y( 0 );
    model().atom( H1 ).set_z( 1 );

    model().atom( H2 ).set_x(-1 );
    model().atom( H2 ).set_y( 0 );
    model().atom( H2 ).set_z(-1 );

    model().atom( H3 ).set_x( 1 );
    model().atom( H3 ).set_y(-1 );
    model().atom( H3 ).set_z( 0 );

    model().atom( H4 ).set_x( 1 );
    model().atom( H4 ).set_y( 1 );
    model().atom( H4 ).set_z( 0 );
//*/

    //Test_spheres_dialog().exec();
}

}//MM
