#include "Qt_menu_control.h"

#include "Qt_command.h"

#include <q3popupmenu.h>

namespace MM
{

Qt_menu_control::Qt_menu_control (Q3PopupMenu & popup_menu)
: popup_menu_(popup_menu)
{
}

void Qt_menu_control::
new_item (const Text & text, Command * command)
{
    new_item (text, command, "");
}

void Qt_menu_control::
new_item (const Text & text, Command * command, const Text & accelator)
{
    bool has_accelator = accelator != "";

    Qt_command * qt_command = new Qt_command (command);
    command_bag_.push_back (qt_command);

    if (has_accelator)
        popup_menu_().insertItem (text.c_str(), qt_command, SLOT (execute()), 
                                  QString (accelator.c_str()));
    else
        popup_menu_().insertItem (text.c_str(), qt_command, SLOT (execute()));
}

void Qt_menu_control::
new_separator()
{
    popup_menu_().insertSeparator();
}

}//MM
