#include "Test.h"

#include "Image.h"
#include "Painter_2D.h"

//fix
#include "__rand.h"
#include "Performance.h"

#include <qdialog.h>
#include <qpainter.h>
//#include <qstatusbar.h>
#include <qlabel.h>
//Added by qt3to4:
#include <QPaintEvent>

namespace MM
{

class Qt_painter_2D_test : public Test
{
public:
    Qt_painter_2D_test( const Text & suite_name ) : Test( suite_name ) { }

    void run()
    {
        test_lines();
        test_lines_speed();
    }

    virtual void    test_lines();
    virtual void    test_lines_speed();
};

//Qt_painter_2D_test qt_painter_2D_test("performance");
Qt_painter_2D_test test_qt_painter_2D ("temporary");

namespace 
{

class Test_lines_dialog : public QDialog
{
    Image                       image_;

public:
    Test_lines_dialog() : QDialog( 0,0, TRUE ), image_( 300, 300 ) { }


    void paintEvent(QPaintEvent*)
    {
        Painter_2D          painter( image_ );
        int                 x=150, y=150;

        painter.move_to( x, y );
        for( int i=0;  i<14;  ++i )
        {
            painter.line_to( x+130, y-10*i );
            painter.line_to( x+10*i, y-130 );

            painter.Wu_line_to( x+130, y+10*i );
            painter.Wu_line_to( x+10*i, y+130 );

            painter.Wu_line2_to( x-130, y+10*i );
            painter.Wu_line2_to( x-10*i, y+130 );

            painter.Wu_line3_to( x-130, y-10*i );
            painter.Wu_line3_to( x-10*i, y-130 );
        }

        QPainter qpainter(this);
        qpainter.drawImage( QPoint(0,0), image_.qimage() );
    }
};

class Test_lines_speed_dialog : public QDialog
{
    Image                       image_;
//    QStatusBar                  *status_bar_;
    QLabel                      *status_bar_label_;

public:
    Test_lines_speed_dialog() 
    : 
        QDialog( 0,0, TRUE ), 
        image_( 300, 300 )
    {
        //status_bar_ = new QStatusBar( this );

        status_bar_label_ = new QLabel( this, "message" );
        //status_bar_label_ = new QLabel( status_bar_, "message" );
        status_bar_label_->setAlignment( Qt::AlignCenter );
        //status_bar_->addWidget( status_bar_label_, 4 );

        status_bar_label_->setText("This is a Status Bar");
    }


    void paintEvent(QPaintEvent*)
    {
        Painter_2D          painter( image_ );
        int                 x=150, y=150;

        T_Base_random random_shift( 130 );
        T_Base_random random_color( 0, 255 );
        x = 450;
        painter.move_to( x, y );
        double t1 = Test_Performance::get_time();
        //int shift = 33;

        for( int i=0;  i<10;  ++i )
        {
            painter.set_foreground_color
                ((unsigned char)random_color.next(), 
		 (unsigned char)random_color.next(), 
		 (unsigned char)random_color.next());

            for( int j=0;  j<10;  ++j )
            {
                int shift = (int)random_shift.next();

                painter.line_to( x+130, y-shift );
                painter.line_to( x+shift, y-130 );

                painter.Wu_line_to( x+130, y+shift );
                painter.Wu_line_to( x+shift, y+130 );

                painter.Wu_line2_to( x-130, y+shift );
                painter.Wu_line2_to( x-shift, y+130 );

                painter.Wu_line3_to( x-130, y-shift );
                painter.Wu_line3_to( x-shift, y-130 );
        }
        }
        double t2 = Test_Performance::get_time();
        status_bar_label_->setText( Text(t2-t1).c_str() );

        QPainter qpainter(this);
        qpainter.drawImage( QPoint(0,0), image_.qimage() );
    }
};

}//namespace

void    Qt_painter_2D_test::
test_lines()
{
    Test_lines_dialog().exec();
}

void    Qt_painter_2D_test::
test_lines_speed()
{
    Test_lines_speed_dialog().exec();
}

}//MM
