#include "Qt_user.h"

#include "Text.h"
#include "Form_choose.h"
#include "Own.h"
#include "Information.h"

#include <qmessagebox.h>
#include <qapplication.h>
#include <qlabel.h>

namespace MM
{

void Qt_user::
fatal_error (const Text & message)
{
    QMessageBox::critical (0 , "", QString::fromLocal8Bit (message.c_str()));
    throw;
}

void Qt_user::
error (const Text & message )
{
    Information::error    (message);
    QMessageBox::critical (0 , "", QString::fromLocal8Bit (message.c_str()));
}

void Qt_user::
warning (const Text & message)
{
    Information::warning  (message);
    QMessageBox::warning (0 , "", QString::fromLocal8Bit (message.c_str()));
}

void Qt_user::
info (const Text & message)
{
//fix
//    QWidget * main_widget = QApplication::mainWidget();
//    QMessageBox::information( main_widget , main_widget.name(), message.c_str() );
    QMessageBox::information (0 , "", QString::fromLocal8Bit (message.c_str()));
}

void Qt_user::
status (const Text & message)
{
    info (message);
}

bool Qt_user::
question (Text const & message)
{
    QMessageBox::StandardButton result = QMessageBox::question 
        (0, "Question", message.c_str(), 
         QMessageBox::Yes | QMessageBox::No, QMessageBox::Yes);

    if (result == QMessageBox::Yes)
        return true;

    return false;
}

bool Qt_user::
choose (Text const & message, Array <Text> const & list, 
        Text & result, int & n)
{
    Form_choose dialog;
    dialog.message->setText (message.c_str());
    
    for (int i=0;  i<list.size();  ++i)
        dialog.listWidget->addItem (list[i].c_str());
    
    int ret = dialog.exec ();
    
    if (ret == QDialog::Accepted && dialog.listWidget->count ())
    {
        result = dialog.listWidget->currentItem()->text().ascii();
        n      = dialog.listWidget->currentRow ();
        return true;
    }

    return false;
}

void Qt_user::
//inquiry (Text const & message, Text & response)//fix
inquiry (Text const &, Text &)//fix
{
    /*//3 Own <Dialog_text_inquiry>  dialog(new Dialog_text_inquiry);
    //3 dialog().message->setText (message.c_str());
    //3 dialog().exec ();
    QDialog dialog;
    Ui::Dialog_text_inquiry ui;
    ui.setupUi (&dialog);
    dialog.exec ();//*/
}

}//MM

