#ifndef FORM_BUILD_CRYSTAL_H
#define FORM_BUILD_CRYSTAL_H

//#ifndef FORM_BUILD_CRYSTAL_BASE_H
#include "ui_Form_build_crystal_base.h"
//#endif

#ifndef DYNAMIC_SINGLETON_H
#include "Dynamic_singleton.h"
#endif

#ifndef MODEL_SINGLETON_VIEW_H
#include "Model_singleton_view.h"
#endif

class QValidator;

namespace MM
{
class Crystal_builder;
class Command;

class Form_build_crystal :
    public QWidget,
    public Ui::Form_build_crystal_base,
    public Dynamic_singleton <Form_build_crystal>,
    public Model_singleton_view
{
    Q_OBJECT

    friend class Dynamic_singleton <Form_build_crystal>;
    Crystal_builder &   builder ();
    
    Command *           update_me_;
    QValidator *        angles_validator_;

public:
    Form_build_crystal();
   ~Form_build_crystal();
    static void         pop_up ();

    void                reset_current_model (Model &);
    void                reset (Model_event::Hint);

    void                update_form ();
    void                update_model_view ();
    void                update_lattice_paramiters ();
    void                update_lattice_vectors ();

public slots:
    virtual void        showEvent (QShowEvent * event);

    void                accept_lattice_paramiters (const QString &);
    void                accept_lattice_vectors    (const QString &);
    virtual void        accept_number_of_copies   (const QString &);
    virtual void        expand_model ();
    virtual void        set_abc_the_same   (int);
    virtual void        show_cell_copies   (int);
    virtual void        update_image_style (int);
    virtual void        from_fractional_to_cartesian();
    virtual void        check_validity ();
};

}//MM

#endif //FORM_BUILD_CRYSTAL_H
