#ifndef PAUSE_SIMULATION_H
#define PAUSE_SIMULATION_H

#ifndef SIMULATION_ITEM_H
#include "Simulation_item.h"
#endif

#ifndef FLAW_H
#include "Flaw.h"
#endif

#ifndef CREATE_H
#include "Create.h"
#endif

namespace MM
{

class Pause_simulation : public Simulation_item
{
public:
    /*explicit Pause_simulation (Simulation_protocol & owner)
    :   Simulation_item (owner)
    {
    }//*/

    Simulation_item * clone (Model &, char const *, Simulation_protocol &) const
        {return new Pause_simulation;}

    virtual Text const& title () const
    {
        static Text result = "Pause simulation";
        return result;
    }

    char const *        class_name () const {return "Pause_simulation";}

    virtual void                execute () {FIX;}
    virtual void                tune  () {FIX;}
    virtual void                start () {FIX;}

    virtual void                make_current   ()   {;}

    bool        support_duration () const       {return false;}
    double      duration         () const       {FLAW("Stub"); return 0.;}
    void        set_duration     (double)       {FLAW("Stub");}

    bool        support_steps    () const       {return false;}
    int         steps            () const       {FLAW("Stub"); return 0;}
    void        set_steps        (int)        {FLAW("Stub");}

    bool        support_temperature   () const  {return false;}
    bool        has_new_temperature   () const  {return false;}
    void        set_new_temperature   (double)  {FLAW("Stub");}
    void        remove_new_temperature()        {FLAW("Stub");}
    double      starting_temperature  () const  {FLAW("Stub"); return 0.;}
    double      final_temperature     () const  {FLAW("Stub"); return 0.;}
    bool        support_thermostat    () const  {return false;}
    bool        has_thermostat        () const  {FLAW("Stub"); return false;}
    void        set_thermostat        (bool)    {FLAW("Stub");}

    void        set_pressure          (double)  {FLAW("Stub");}
    double      pressure              () const   {FLAW("Stub"); return 0.;}
    //bool        support_pressure      () const  {return false;}
    //bool        has_new_pressure      () const  {return false;}
    //void        set_new_pressure      (double v){FLAW("Stub");}
    //void        remove_new_pressure   ()        {FLAW("Stub");}
    //double      starting_pressure     () const  {FLAW("Stub"); return 0.;}
    //double      final_pressure        () const  {FLAW("Stub"); return 0.;}
    bool        support_barostat      () const  {return false;}
    bool        has_barostat          () const  {FLAW("Stub"); return false;}
    void        set_barostat          (bool)    {FLAW("Stub");}

    bool                support_simulator () const {return false;}
    Simulator &         simulator   ()             {FLAW("Stub");}
    Simulator const&    simulator   () const       {FLAW("Stub");
                                                    return nil<Simulator>();}
    void                adopt_simulator (Simulator *) {FLAW("Stub");}
};

}//MM

#endif //PAUSE_SIMULATION_H
