#include "Form_M_DynaMix_options.h"

#include "M_DynaMix_input.h"
#include "Form_main_window.h"
#include "Qt_application.h"
//Added by qt3to4:
#include <QShowEvent>
#include "Mach_eps.h"
#include "Box.h"
#include "Model.h"
#include "Model_kit.h"
#include "Project.h"
#include "Project_kit.h"
#include "Protocol_cursor.h"
#include "Protocol_stage.h"
#include "Command_template.h"
#include "Simulator.h"
//#include "Form_protocol.h"

//fix remove
#include "Atom_group.h"
#include "Model_proxy.h"

#include <qapplication.h>
#include <qvalidator.h>
#include <qcombobox.h>
#include <qlineedit.h>
#include <qstring.h>
#include <qradiobutton.h>
#include <qcheckbox.h>

#include <limits>

namespace MM
{
/*M_DynaMix_input * Form_M_DynaMix_options::
option()
{
    Protocol_stage &tage = 
        Project::singleton().kit().protocol().cursor().current();


}//*/


Form_M_DynaMix_options::
Form_M_DynaMix_options ()
:
    option_(0)
{
    using namespace std;

    setupUi (this);

    connect (comboBox_Output_control,                                 SIGNAL(activated(int)),              this, SLOT(set_output_control(int)));
    connect (lineEdit_box_x,                                          SIGNAL(textChanged(const QString&)), this, SLOT(set_box_x(const QString&)));
    connect (lineEdit_box_y,                                          SIGNAL(textChanged(const QString&)), this, SLOT(set_box_y(const QString&)));
    connect (lineEdit_box_z,                                          SIGNAL(textChanged(const QString&)), this, SLOT(set_box_z(const QString&)));
    connect (checkBox_Constrain_dynamics,                             SIGNAL(toggled(bool)),               this, SLOT(set_constrain_dynamics(bool)));
    connect (lineEdit_Tolerance_parameter,                            SIGNAL(textChanged(const QString&)), this, SLOT(set_tolerance_parameter(const QString&)));
    connect (checkBox_Cut_large_forces,                               SIGNAL(toggled(bool)),               this, SLOT(set_cut_large_forces(bool)));
    connect (lineEdit_Max_level_of_large_forces,                      SIGNAL(textChanged(const QString&)), this, SLOT(set_max_level_of_large_forces(const QString&)));
    connect (lineEdit_Time_step,                                      SIGNAL(textChanged(const QString&)), this, SLOT(set_time_step(const QString&)));
    connect (lineEdit_Small_steps_in_one_long,                        SIGNAL(textChanged(const QString&)), this, SLOT(set_small_steps_in_one_long(const QString&)));
    connect (lineEdit_Steps_for_intermediate_averaging,               SIGNAL(textChanged(const QString&)), this, SLOT(set_steps_for_intermediate_averaging(const QString&)));
    connect (lineEdit_Dump_restart_file_after___steps,                SIGNAL(textChanged(const QString&)), this, SLOT(set_dump_restart_file_after___steps(const QString&)));
    connect (lineEdit_Final_averaging_after___intermediate_averaging, SIGNAL(textChanged(const QString&)), this, SLOT(set_final_averaging_after___intermediate_averaging(const QString&)));
//    connect (pushButton_Load_input_file,                              SIGNAL(clicked()),                   this, SLOT(load_input_file()));
//    connect (pushButton_Save_input_file,                              SIGNAL(clicked()),                   this, SLOT(save_input_file()));
//    connect (lineEdit_DB_path,                                        SIGNAL(textChanged(const QString&)), this, SLOT(set_db_path(const QString&)));
//    connect (lineEdit_Main_file_name,                                 SIGNAL(textChanged(const QString&)), this, SLOT(set_output_name(const QString&)));
    connect (radioButton_Nose_thermostat,                             SIGNAL(toggled(bool)),               this, SLOT(set_Nose_thermostat(bool)));
    connect (radioButton_Simple_scaling_thermostat,                   SIGNAL(toggled(bool)),               this, SLOT(set_simple_scaling_thermostat(bool)));
    connect (lineEdit_Thermostat_parameter,                           SIGNAL(textChanged(const QString&)), this, SLOT(set_thermostat_parameter(const QString&)));
    connect (line_Simple_scaling_delta,                               SIGNAL(textChanged(const QString&)), this, SLOT(set_simple_scaling_delta(const QString&)));
    connect (lineEdit_Barostat_parameter,                             SIGNAL(textChanged(const QString&)), this, SLOT(set_barostat_parameter(const QString&)));
    connect (checkBox_Anizotropic_NPT,                                SIGNAL(toggled(bool)),               this, SLOT(set_anizotropic_NPT(bool)));
    connect (radioButton_Vacuum,                                      SIGNAL(toggled(bool)),               this, SLOT(set_vacuum(bool)));
    connect (radioButton_Box,                                         SIGNAL(toggled(bool)),               this, SLOT(set_box(bool)));
    connect (lineEdit_LJ_cutoff,                                      SIGNAL(textChanged(const QString&)), this, SLOT(set_LJ_cutoff(const QString&)));
    connect (lineEdit_Fast_forces_cutoff,                             SIGNAL(textChanged(const QString&)), this, SLOT(set_fast_forces_cutoff(const QString&)));
    connect (lineEdit_exp,                                            SIGNAL(textChanged(const QString&)), this, SLOT(set_ewald_exp(const QString&)));
    connect (lineEdit_alpha_R,                                        SIGNAL(textChanged(const QString&)), this, SLOT(set_ewald_alpha_R(const QString&)));
    connect (lineEdit_Dump_restart_file_after___steps,                SIGNAL(textChanged(const QString&)), this, SLOT(set_dump_restart_file_after___steps(const QString&)));
    connect (lineEdit_Check_neigbours_after___series,                 SIGNAL(textChanged(const QString&)), this, SLOT(set_check_neigbours_after___series(const QString&)));
    connect (checkBox_Read_restart,                                   SIGNAL(toggled(bool)),               this, SLOT(set_read_restart(bool)));
    connect (checkBox_Dump_restart,                                   SIGNAL(toggled(bool)),               this, SLOT(set_dump_restart(bool)));
    connect (checkBox_Change_temperature_at_restart,                  SIGNAL(toggled(bool)),               this, SLOT(set_change_temperature_at_restart(bool)));
    connect (radioButton_Manual,                                      SIGNAL(toggled(bool)),               this, SLOT(set_box_manual(bool)));
    connect (radioButton_From_crystal,                                SIGNAL(toggled(bool)),               this, SLOT(set_box_from_crystal(bool)));
    connect (radioButton_Auto_box,                                    SIGNAL(toggled(bool)),               this, SLOT(set_box_auto(bool)));
    connect (lineEdit_Time_step,                                      SIGNAL(lostFocus()),                 this, SLOT(lineEdit_Time_step_lostFocus()));
    connect (lineEdit_Time_step,                                      SIGNAL(returnPressed()),             this, SLOT(lineEdit_Time_step_returnPressed()));

    comboBox_Output_control->insertItem ("2 Minimal");
    comboBox_Output_control->insertItem ("3");
    comboBox_Output_control->insertItem ("4 Short");
    comboBox_Output_control->insertItem ("5 Normal");
    comboBox_Output_control->insertItem ("6");
    comboBox_Output_control->insertItem ("7 Exhaustive");
    comboBox_Output_control->insertItem ("8");
    comboBox_Output_control->insertItem ("9");
    comboBox_Output_control->insertItem ("10 Debug");

//    lineEdit_DB_path->setValidator (new QRegExpValidator 
//        (QRegExp("([+-9]|[a-z]|[A-Z]|[~^_!]|[\\0134])+"), this));

//    lineEdit_Main_file_name->setValidator (new QRegExpValidator 
//        (QRegExp("([+-9]|[a-z]|[A-Z]|[~^_!]|[\\0134])+"), this));
//        (new QRegExpValidator (QRegExp("\\w+$"), this));
//        (new QRegExpValidator (QRegExp("\\S+"), this));

    lineEdit_Thermostat_parameter->setValidator (new QDoubleValidator (this));
    //lineEdit_Thermostat_parameter->setValidator 
    //    (new QDoubleValidator (0, numeric_limits<double>::max(), 15, this));

    line_Simple_scaling_delta   ->setValidator (new QDoubleValidator (this));
    lineEdit_Barostat_parameter ->setValidator (new QDoubleValidator (this));
    //lineEdit_Density            ->setValidator (new QDoubleValidator (this));
    lineEdit_box_x              ->setValidator (new QDoubleValidator (this));
    lineEdit_box_y              ->setValidator (new QDoubleValidator (this));
    lineEdit_box_z              ->setValidator (new QDoubleValidator (this));
    lineEdit_LJ_cutoff          ->setValidator (new QDoubleValidator (this));
    lineEdit_Fast_forces_cutoff ->setValidator (new QDoubleValidator (this));
    lineEdit_alpha_R            ->setValidator (new QDoubleValidator (this));
    lineEdit_exp                ->setValidator (new QDoubleValidator (this));
    lineEdit_Tolerance_parameter->setValidator (new QDoubleValidator (this));
    lineEdit_Max_level_of_large_forces
                                ->setValidator (new QDoubleValidator (this));
    lineEdit_Time_step          ->setValidator (new QDoubleValidator (this));
    lineEdit_Small_steps_in_one_long
                                ->setValidator (new QIntValidator (this));
    lineEdit_Steps_for_intermediate_averaging
                                ->setValidator (new QIntValidator (this));
    lineEdit_Dump_restart_file_after___steps
                                ->setValidator (new QIntValidator (this));
    lineEdit_Check_neigbours_after___series
                                ->setValidator (new QIntValidator (this));
    lineEdit_Final_averaging_after___intermediate_averaging
                                ->setValidator (new QIntValidator (this));

    //update_me_ = create_command (*this, &Form_M_DynaMix_options::update);
    //Project::singleton().on_change_current (update_me_);
}

Form_M_DynaMix_options::
~Form_M_DynaMix_options ()
{
//    Project::singleton().on_change_current (update_me_, false);
//    update_me_ = 0;
    option_ = 0;
}

void Form_M_DynaMix_options::
pop_up ()
{
    Form_main_window &main_window 
        = Qt_application::singleton().main_window();

    if (Form_M_DynaMix_options::exist())
        main_window.pop_up (Form_M_DynaMix_options::singleton());
    else
        main_window.add_left_control
            (Form_M_DynaMix_options::singleton(), "m.DynaMix");
}

void Form_M_DynaMix_options::  //fix
update_form ()
{
    //if (Project::singleton().kit().protocol().cursor().is_valid())
//    Model *none = &Model::none();

    Project &  project       = Project::singleton();
//    Model *current          = &project.current_model();
    Protocol & protocol      = project.kit().protocol();
//    Model *real             = protocol.model().real_model();
    Protocol_cursor & cursor = protocol.cursor();
    if (cursor.is_valid())
        cursor.current().update();


    /*//if (option_!=0) update_for (*option_);
    Simulation_item & item = Project::singleton().current_model().kit()
        .simulation_protocol ().selected_item();

    if (item.support_simulator())
    {
        setEnabled (true);
        item.simulator().update();
    }
    else 
    {
        setEnabled (false);
    }//*/
}

void Form_M_DynaMix_options::
update_for (M_DynaMix_input & option)
{
    static bool reinter_flag = false;//fix
    if (reinter_flag)
        return;
    reinter_flag = true;

    if (Project::singleton().model_count() == 0)//fix
        return;

    option_ = &option;
    setEnabled (true);

//    lineEdit_DB_path->setText (option.molecular_database_path_.c_str());
    comboBox_Output_control->setCurrentItem (option.output_control_ - 2);
//    lineEdit_Main_file_name->setText (option.main_file_name_.c_str());

    if (option.is_simple_velosity_scaling_)
        radioButton_Simple_scaling_thermostat->setChecked(true);
    else
        radioButton_Nose_thermostat->setChecked(true);

    lineEdit_Thermostat_parameter->setText (QString::number 
        (option.t_termostat_));

    line_Simple_scaling_delta->setText (QString::number
        (option.delta_t_));

    lineEdit_Barostat_parameter->setText (QString::number
        (option.p_termostat_));

    checkBox_Anizotropic_NPT->setChecked 
        (option.anizotropic_NPT_);

    /*const double tolerance = ::d_mach_eps_2;
    if (option.box_x() < tolerance || 
        option.box_y() < tolerance || 
        option.box_z() < tolerance)
    {
        if (option.density_ < tolerance)
        {
            // Vacuum
            radioButton_Vacuum->setChecked (true);
            
            lineEdit_box_x->setEnabled (false);
            lineEdit_box_y->setEnabled (false);
            lineEdit_box_z->setEnabled (false);
        }
        else
        {
            FLAW ("No such option.");
        }
    }
    else 
    {
        // Box
        radioButton_Box->setChecked (true);

        lineEdit_box_x->setEnabled (true);
        lineEdit_box_y->setEnabled (true);
        lineEdit_box_z->setEnabled (true);
    }
    lineEdit_box_x  ->setText (QString::number (option.box_x()));
    lineEdit_box_y  ->setText (QString::number (option.box_y()));
    lineEdit_box_z  ->setText (QString::number (option.box_z()));//*/
    
    //fix !!!!!!!
    //if (option.model().kit().boundary_conditions().type_name () == "Vacuum")
    if (Project::singleton().current_model().kit().
        boundary_conditions().type_name () == "Vacuum")
    {
        radioButton_Vacuum->        setChecked (true);
        
        lineEdit_box_x->            setEnabled (false);
        lineEdit_box_y->            setEnabled (false);
        lineEdit_box_z->            setEnabled (false);
        radioButton_Manual->        setEnabled (false);
        radioButton_From_crystal->  setEnabled (false);
        radioButton_Auto_box->      setEnabled (false);
        lineEdit_alpha_R->          setEnabled (false);
        lineEdit_exp->              setEnabled (false);
    }
    else if (option.model().kit().boundary_conditions().type_name () == "Box")
    {
        radioButton_Box->           setChecked (true);

        lineEdit_box_x->            setEnabled (true);
        lineEdit_box_y->            setEnabled (true);
        lineEdit_box_z->            setEnabled (true);
        radioButton_Manual->        setEnabled (true);
        
        if (option.model().kit().has_crystal_cell ())
        {
            radioButton_From_crystal->  setEnabled (true);

            if (option.model().kit().boundary_conditions().
                is_box_a_crystal_cell())
                    radioButton_From_crystal-> setChecked (true);
            else
            {
                radioButton_Manual->        setChecked (true);
            }
        }
        else
        {
            radioButton_From_crystal->  setEnabled (false);
            radioButton_Manual->        setChecked (true);
        }
        //radioButton_Auto_box->      setEnabled (true);

        lineEdit_box_x  ->setText (QString::number (option.box_x()));
        lineEdit_box_y  ->setText (QString::number (option.box_y()));
        lineEdit_box_z  ->setText (QString::number (option.box_z()));

        lineEdit_alpha_R->          setEnabled (true);
        lineEdit_exp->              setEnabled (true);
    }
    else
    {
        radioButton_Vacuum->        setChecked (false);
        radioButton_Box->           setChecked (false);

        lineEdit_box_x->            setEnabled (false);
        lineEdit_box_y->            setEnabled (false);
        lineEdit_box_z->            setEnabled (false);
        radioButton_Manual->        setEnabled (false);
        radioButton_From_crystal->  setEnabled (false);
        radioButton_Auto_box->      setEnabled (false);
        lineEdit_alpha_R->          setEnabled (false);
        lineEdit_exp->              setEnabled (false);
   }

    lineEdit_LJ_cutoff->setText (QString::number 
        (option.r_cutoff_));
    
    lineEdit_Fast_forces_cutoff->setText (QString::number 
        (option.r_cutoff_fast_force_));

    lineEdit_alpha_R->setText (QString::number 
        (option.alpha_r_));

    lineEdit_exp->setText (QString::number 
        (option.fexp_));

    checkBox_Constrain_dynamics->setChecked (option.constrain_dynamics_);

    lineEdit_Tolerance_parameter->setText (QString::number
        (option.tolerance_parameter_));

    checkBox_Cut_large_forces->setChecked (option.cut_large_forces_);

    lineEdit_Max_level_of_large_forces->setText (QString::number
        (option.max_level_of_large_forces_));

    lineEdit_Time_step->blockSignals (true);
    lineEdit_Time_step->setText (QString::number
        //(option.time_step().step_length()*1000));
        (Project::singleton().kit().protocol().cursor().current()
        .option("Step length").to_double() * 1000));
    lineEdit_Time_step->blockSignals (false);

    lineEdit_Small_steps_in_one_long->setText (QString::number
        (option.small_steps_in_one_long_));

    lineEdit_Steps_for_intermediate_averaging->setText (QString::number
        (option.steps_for_intermediate_averaging_));

    lineEdit_Dump_restart_file_after___steps->setText (QString::number
        (option.dump_restart_file_after___steps_));

    lineEdit_Check_neigbours_after___series->setText (QString::number
        (option.check_neigbours_after___step_));

    lineEdit_Final_averaging_after___intermediate_averaging->setText (QString::number
        (option.final_averaging_after___intermediate_averaging_));
    
    checkBox_Read_restart->setChecked (option.read_from_restart_file_);
    checkBox_Dump_restart->setChecked (option.dump_restart_file_);
    checkBox_Change_temperature_at_restart
                         ->setChecked (option.change_temperature_at_restart_);

    reinter_flag = false;
}

void Form_M_DynaMix_options::
set_db_path (const QString & path)
{
    INVARIANT;
    option_->molecular_database_path_ = path.latin1();
}

void Form_M_DynaMix_options::
set_output_control (int n)
{
    INVARIANT;
    option_->output_control_ = n + 2;
}

void Form_M_DynaMix_options::
set_main_name (const QString & name)
{
    INVARIANT;
    option_->main_file_name_ = name.latin1();
}

void Form_M_DynaMix_options::
set_Nose_thermostat (bool on)
{
    INVARIANT;
    if (on)
        option_->is_simple_velosity_scaling_ = false;
}

void Form_M_DynaMix_options::
set_simple_scaling_thermostat (bool on)
{
    INVARIANT;
    if (on)
        option_->is_simple_velosity_scaling_ = true;
}

void Form_M_DynaMix_options::
set_thermostat_parameter (const QString& value)
{
    INVARIANT;
    option_->t_termostat_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_simple_scaling_delta (const QString& value)
{
    INVARIANT;
    option_->delta_t_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_barostat_parameter (const QString& value)
{
    INVARIANT;
    option_->p_termostat_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_anizotropic_NPT (bool on)
{
    INVARIANT;
    option_->anizotropic_NPT_ = on;
}

void Form_M_DynaMix_options::
set_vacuum (bool on)
{
    INVARIANT;

    if (on)
    {
        option_->set_vacuum ();
        update_for (*option_);
    }
}

/*void Form_M_DynaMix_options::
set_box_from_density (bool on)//fix remove
{
    INVARIANT;
    option_->box_x_   = 0;
    option_->box_y_   = 0;
    option_->box_z_   = 0;
    option_->density_ = 1;//fix
    update (*option_);
}//*/

void Form_M_DynaMix_options::
set_box (bool on)
{
    INVARIANT;

    if (on)
    {
        option_->set_box ();

        // Manual
        // From crystal
        // Auto

        update_for (*option_);
    }
}

/*void Form_M_DynaMix_options::
set_density (const QString& value)
{
    INVARIANT;
    option_->density_ = value.toDouble();
    update (*option_);
}//*/

void Form_M_DynaMix_options::
set_box_manual (bool on)
{
    if (on)
    {
        Boundary_conditions &boundary_conditions 
            = option_->model().kit().boundary_conditions ();
    
        if (boundary_conditions.is_box_a_crystal_cell ())
            boundary_conditions.reject_crystal_cell_as_a_box ();
        //fix auto

        //else
        //    boundary_conditions.set_type ("Box");

        update_for (*option_);
    }
}

void Form_M_DynaMix_options::
set_box_from_crystal (bool on)
{
    if (on)
    {
        Boundary_conditions &boundary_conditions 
            = option_->model().kit().boundary_conditions ();

        boundary_conditions.accept_crystal_cell_as_a_box ();
        update_for (*option_);
    }
}

void Form_M_DynaMix_options::
set_box_auto (bool on)
{
    if (on)
    {
    }
}

void Form_M_DynaMix_options::
set_box_x (const QString& value)
{
    INVARIANT;
    if (value.toDouble() < ::d_mach_eps_2)
        return;
    //option_->box_x_ = value.toDouble();
    Box & box = option_->model().kit().boundary_conditions ().box();
    box.scale_a (value.toDouble() / box.a_mod());
    //fix update (*option_);
}

void Form_M_DynaMix_options::
set_box_y (const QString& value)
{
    INVARIANT;
    if (value.toDouble() < ::d_mach_eps_2)
        return;
    //option_->box_y_ = value.toDouble();
    Box & box = option_->model().kit().boundary_conditions ().box();
    box.scale_b (value.toDouble() / box.b_mod());
    //fix update (*option_);
}

void Form_M_DynaMix_options::
set_box_z (const QString& value)
{
    INVARIANT;
    if (value.toDouble() < ::d_mach_eps_2)
        return;
    //option_->box_z_ = value.toDouble();
    Box & box = option_->model().kit().boundary_conditions ().box();
    box.scale_c (value.toDouble() / box.c_mod());
    //fix update (*option_);
}

void Form_M_DynaMix_options::
set_LJ_cutoff (const QString& value)
{
    INVARIANT;
    option_->r_cutoff_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_fast_forces_cutoff (const QString& value)
{
    INVARIANT;
    option_->r_cutoff_fast_force_ = value.toDouble();
}

void Form_M_DynaMix_options:://fix
suggest_cutoff ()
{
    INVARIANT;

    double L;
    if (radioButton_Box->isChecked ())
    {
        L = (option_->box_x()+option_->box_y()+option_->box_z())/3.;
    }
    /*else if (radioButton_Density->isChecked ())
    {
        L = 0;//fix impl
    }//*/
    else if (radioButton_Vacuum->isChecked ())
    {
        option_->r_cutoff_ = 100.;
        lineEdit_LJ_cutoff ->setText (QString::number (option_->r_cutoff_));
        return;
    }
    else 
        FLAW ("No such state.");

    if (L >= 20)
        option_->r_cutoff_ = 0.1*(L-10.) + 10.;
    else
        option_->r_cutoff_ = 10.;

    lineEdit_LJ_cutoff ->setText (QString::number (option_->r_cutoff_));
}

void Form_M_DynaMix_options::
set_ewald_alpha_R (const QString& value)
{
    INVARIANT;
    option_->alpha_r_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_ewald_exp (const QString& value)
{
    INVARIANT;
    option_->fexp_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_constrain_dynamics (bool on)
{
    INVARIANT;
    option_->constrain_dynamics_ = on;
}

void Form_M_DynaMix_options::
set_tolerance_parameter (const QString& value)
{
    INVARIANT;
    option_->tolerance_parameter_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_cut_large_forces (bool on)
{
    INVARIANT;
    option_->cut_large_forces_ = on;
}

void Form_M_DynaMix_options::
set_max_level_of_large_forces (const QString& value)
{
    INVARIANT;
    option_->max_level_of_large_forces_ = value.toDouble();
}

void Form_M_DynaMix_options::
set_time_step (const QString& value)
{
    INVARIANT;
    //option_->time_step_ = value.toDouble();
    //option_->time_step().set_step_length (value.toDouble()/1000);
    /*Duration_unit s = option_->time_step();
    s.set_step_length (value.toDouble() / 1000);
    option_->set_time_step (s);//*/
    //set_option ()

    Protocol_stage & stage = 
        Project::singleton().kit().protocol().cursor().current();

    stage. set_option("Step length", value.toDouble() / 1000);
    stage. update ();

    //fix
    //Model_manager::singleton().current().kit()
    //    .simulation_protocol().selected_item().set_step_length()
        //.set_duration (option_->time_step_ * option_->total_long_steps_);

    //fix remove
    //if (Form_protocol::exist ())
    //    Form_protocol::singleton ()->update_simulation_protocol ();
}

void Form_M_DynaMix_options::
lineEdit_Time_step_lostFocus ()
{
//    if (Form_simulation::exist ())
//        Form_simulation::singleton ()->update_simulation_protocol ();
}

void Form_M_DynaMix_options::
lineEdit_Time_step_returnPressed ()
{
//    if (Form_simulation::exist ())
//        Form_simulation::singleton ()->update_simulation_protocol ();
}

void Form_M_DynaMix_options::
set_small_steps_in_one_long (const QString& value)
{
    INVARIANT;
    option_->small_steps_in_one_long_ = value.toInt();
}

/*void Form_M_DynaMix_options::
set_total_long_steps (const QString& value)
{
    INVARIANT;
    option_->small_steps_in_one_long_ = value.toInt();
}//*/

void Form_M_DynaMix_options::
set_steps_for_intermediate_averaging (const QString& value)
{
    INVARIANT;
    option_->steps_for_intermediate_averaging_ = value.toInt();
}

void Form_M_DynaMix_options::
set_dump_restart_file_after___steps (const QString& value)
{
    INVARIANT;
    option_->dump_restart_file_after___steps_ = value.toInt();
}

void Form_M_DynaMix_options::
set_check_neigbours_after___series (const QString& value)
{
    INVARIANT;
    option_->check_neigbours_after___step_ = value.toInt();
}

void Form_M_DynaMix_options::
set_final_averaging_after___intermediate_averaging (const QString& value)
{
    INVARIANT;
    option_->final_averaging_after___intermediate_averaging_ = value.toInt();
}

void Form_M_DynaMix_options::
showEvent (QShowEvent * event)
{
    if (Project::singleton().model_count() != 0)
        update_form ();

    QWidget::showEvent(event);
}

void Form_M_DynaMix_options::
set_read_restart (bool on)
{
    INVARIANT;
    option_->read_from_restart_file_ = on;
}

void Form_M_DynaMix_options::
set_dump_restart (bool on)
{
    INVARIANT;
    option_->dump_restart_file_ = on;
}

void Form_M_DynaMix_options::
set_change_temperature_at_restart (bool on)
{
    INVARIANT;
    option_->change_temperature_at_restart_ = on;
}

}//MM


















