#ifndef FORM_M_DYNAMIX_OPTIONS_H
#define FORM_M_DYNAMIX_OPTIONS_H

#ifndef UI_FORM_M_DYNAMIX_OPTIONS_BASE_H
#include "ui_Form_M_DynaMix_options_base.h"
#endif

#ifndef DYNAMIC_SINGLETON_H
#include "Dynamic_singleton.h"
#endif

#include "Model_singleton_view.h"

namespace MM
{
class M_DynaMix_input;
class Command;

class Form_M_DynaMix_options
:
    public QWidget,
    public Ui::Form_M_DynaMix_options_base,
    public Dynamic_singleton <Form_M_DynaMix_options>,
    public Model_singleton_view
{
    Q_OBJECT

    M_DynaMix_input *   option_;
    //Command *           update_me_;

    //M_DynaMix_input *       option();

public:
    Form_M_DynaMix_options ();
   ~Form_M_DynaMix_options ();

    static void     pop_up ();
//    virtual bool    invariant() const {return option_ != 0;}

    void            reset_current_model (Model &) {update_form ();}
    void            reset (Model_event::Hint)     {update_form ();}

    void            update_for (M_DynaMix_input & );
    void            update_form ();

public slots:
    virtual void    showEvent (QShowEvent * event);

    virtual void    set_db_path                     (const QString&);
    virtual void    set_output_control              (int);
    virtual void    set_main_name                   (const QString&);
    virtual void    set_Nose_thermostat             (bool);
    virtual void    set_simple_scaling_thermostat   (bool);
    virtual void    set_thermostat_parameter        (const QString&);
    virtual void    set_simple_scaling_delta        (const QString&);
    virtual void    set_barostat_parameter          (const QString&);
    virtual void    set_anizotropic_NPT             (bool);
    virtual void    set_vacuum                      (bool);
    //virtual void    set_box_from_density            (bool);
    virtual void    set_box                         (bool);
    //virtual void    set_density                     (const QString&);
    virtual void    set_box_manual                  (bool);
    virtual void    set_box_from_crystal            (bool);
    virtual void    set_box_auto                    (bool);
    virtual void    set_box_x                       (const QString&);
    virtual void    set_box_y                       (const QString&);
    virtual void    set_box_z                       (const QString&);

    virtual void    set_LJ_cutoff                   (const QString&);
    virtual void    set_fast_forces_cutoff          (const QString&);
    virtual void    suggest_cutoff                  ();
    virtual void    set_ewald_alpha_R               (const QString&);
    virtual void    set_ewald_exp                   (const QString&);
    virtual void    set_constrain_dynamics          (bool);
    virtual void    set_tolerance_parameter         (const QString&);
    virtual void    set_cut_large_forces            (bool);
    virtual void    set_max_level_of_large_forces   (const QString&);
    virtual void    set_time_step                   (const QString&);
    virtual void    lineEdit_Time_step_lostFocus    ();
    virtual void    lineEdit_Time_step_returnPressed();

    virtual void    set_small_steps_in_one_long     (const QString&);
    virtual void    set_steps_for_intermediate_averaging(const QString&);
    virtual void    set_dump_restart_file_after___steps (const QString&);
    virtual void    set_check_neigbours_after___series(const QString&);
    virtual void    set_final_averaging_after___intermediate_averaging
                                                    (const QString&);
    virtual void    set_read_restart(bool);
    virtual void    set_dump_restart(bool);
    virtual void    set_change_temperature_at_restart(bool);
};

}//MM

#endif //FORM_M_DYNAMIX_OPTIONS_H
