#ifndef M_DYNAMIX_QPROCESS_H
#define M_DYNAMIX_QPROCESS_H

#ifndef M_DYNAMIX_PROCESS_H
#include "M_DynaMix_process.h"
#endif

#ifndef OWN_H
#include "Own.h"
#endif

#ifndef FILE_TEXT_OUTPUT_H
#include "File_text_output.h"
#endif

#include <q3process.h>
#include <qobject.h>

namespace MM
{

class M_DynaMix_QProcess : public QObject, public M_DynaMix_process
{
    Q_OBJECT

    enum {none, read_coords}            state_;

    Q3Process *                          process_;
    Own <Q3Process>                      janitor_;
    Text                                comment_;
    Atom_group *                        ordered_atoms_;
    Own <File_text_output>              output_;
    int                                 current_atom_number_;

public:
    explicit M_DynaMix_QProcess (Interface_for_M_DynaMix_process & simulator);
    void    start (Atom_group * ordered_atoms);
    //void    stop  ();

protected slots:
    virtual void                read_from_stdout();
};

}//MM

#endif //M_DYNAMIX_QPROCESS_H
